{
	"namespace": "custom_actionbar",
	"custom_actionbar_factory": {
		"type": "panel",
		"factory": {
			"name": "hud_actionbar_text_factory",
			"control_ids": {
				"hud_actionbar_text": "custom_actionbar@custom_actionbar.actionbar_root"
			}
		}
	},
	"actionbar_root": {
		"type": "panel",
		"$display_text": "$actionbar_text",
		"$custom_actionbar_keywords_text": "$actionbar_text",
		"$is_vanilla": true,
		"$is_image": false,
		"$fade_in_time": 0,
		"$fade_stay_time": 2,
		"$fade_out_time": 1,
		"$scale_in_time": 1,
		"$scale_stay_time": 2,
		"$scale_out_time": 0,
		"$animate_scale": false,
		"$subject_alpha": 1,
		"$background_alpha": 0,
		"$anchor": "center",
		"$pin_to_actionbar": true,
		"$font": "default",
		"$show_shadow": false,
		"$subject_size": [
			"100%",
			"100%"
		],
		"$subject_offset": [
			0,
			0
		],
		"$should_show": true,
		"visible": "$should_show",
		"controls": [
			{
				"vanilla@custom_actionbar.vanilla_actionbar": {
					"visible": "$is_vanilla"
				}
			},
			{
				"image@custom_actionbar.image_actionbar": {
					"visible": "$is_image"
				}
			},
			{
				"label@custom_actionbar.label_actionbar": {
					"visible": "(not ($is_image or $is_vanilla))"
				}
			}
		],
		"variables": [
			{
				"requires": "(not (($display_text - '{') = $display_text))",
				"$is_vanilla": false
			},
			{
				"requires": "(not (($display_text - 'img:') = $display_text))",
				"$is_image": true
			},
			{
				"requires": "(not (($display_text - 'alpha:0.0') = $display_text))",
				"$subject_alpha": 0
			},
			{
				"requires": "(not (($display_text - 'alpha:0.1') = $display_text))",
				"$subject_alpha": 0.1
			},
			{
				"requires": "(not (($display_text - 'alpha:0.2') = $display_text))",
				"$subject_alpha": 0.2
			},
			{
				"requires": "(not (($display_text - 'alpha:0.3') = $display_text))",
				"$subject_alpha": 0.3
			},
			{
				"requires": "(not (($display_text - 'alpha:0.4') = $display_text))",
				"$subject_alpha": 0.4
			},
			{
				"requires": "(not (($display_text - 'alpha:0.5') = $display_text))",
				"$subject_alpha": 0.5
			},
			{
				"requires": "(not (($display_text - 'alpha:0.6') = $display_text))",
				"$subject_alpha": 0.6
			},
			{
				"requires": "(not (($display_text - 'alpha:0.7') = $display_text))",
				"$subject_alpha": 0.7
			},
			{
				"requires": "(not (($display_text - 'alpha:0.8') = $display_text))",
				"$subject_alpha": 0.8
			},
			{
				"requires": "(not (($display_text - 'alpha:0.9') = $display_text))",
				"$subject_alpha": 0.9
			},
			{
				"requires": "(not (($display_text - 'alpha:1.0') = $display_text))",
				"$subject_alpha": 1
			},
			{
				"requires": "(not (($display_text - 'bg:true') = $display_text))",
				"$background_alpha": 0.6
			},
			{
				"requires": "(not (($display_text - 'hide:true') = $display_text))",
				"$should_show": false
			},
			{
				"requires": "(not (($display_text - 'anchor:top_left') = $display_text))",
				"$anchor": "top_left",
				"$pin_to_actionbar": false
			},
			{
				"requires": "(not (($display_text - 'anchor:top_middle') = $display_text))",
				"$anchor": "top_middle",
				"$pin_to_actionbar": false
			},
			{
				"requires": "(not (($display_text - 'anchor:top_right') = $display_text))",
				"$anchor": "top_right",
				"$pin_to_actionbar": false
			},
			{
				"requires": "(not (($display_text - 'anchor:left_middle') = $display_text))",
				"$anchor": "left_middle",
				"$pin_to_actionbar": false
			},
			{
				"requires": "(not (($display_text - 'anchor:center') = $display_text))",
				"$anchor": "center",
				"$pin_to_actionbar": false
			},
			{
				"requires": "(not (($display_text - 'anchor:right_middle') = $display_text))",
				"$anchor": "right_middle",
				"$pin_to_actionbar": false
			},
			{
				"requires": "(not (($display_text - 'anchor:bottom_left') = $display_text))",
				"$anchor": "bottom_left",
				"$pin_to_actionbar": false
			},
			{
				"requires": "(not (($display_text - 'anchor:bottom_middle') = $display_text))",
				"$anchor": "bottom_middle",
				"$pin_to_actionbar": false,
				"$subject_offset": [
					0,
					-41
				]
			},
			{
				"requires": "(not (($display_text - 'anchor:bottom_right') = $display_text))",
				"$anchor": "bottom_right",
				"$pin_to_actionbar": false
			},
			{
				"requires": "(not (($display_text - 'alpha_in:0') = $display_text))",
				"$fade_in_time": 0
			},
			{
				"requires": "(not (($display_text - 'alpha_in:1') = $display_text))",
				"$fade_in_time": 1
			},
			{
				"requires": "(not (($display_text - 'alpha_in:2') = $display_text))",
				"$fade_in_time": 2
			},
			{
				"requires": "(not (($display_text - 'alpha_in:3') = $display_text))",
				"$fade_in_time": 3
			},
			{
				"requires": "(not (($display_text - 'alpha_in:4') = $display_text))",
				"$fade_in_time": 4
			},
			{
				"requires": "(not (($display_text - 'alpha_in:5') = $display_text))",
				"$fade_in_time": 5
			},
			{
				"requires": "(not (($display_text - 'alpha_stay:0') = $display_text))",
				"$fade_stay_time": 0
			},
			{
				"requires": "(not (($display_text - 'alpha_stay:1') = $display_text))",
				"$fade_stay_time": 1
			},
			{
				"requires": "(not (($display_text - 'alpha_stay:2') = $display_text))",
				"$fade_stay_time": 2
			},
			{
				"requires": "(not (($display_text - 'alpha_stay:3') = $display_text))",
				"$fade_stay_time": 3
			},
			{
				"requires": "(not (($display_text - 'alpha_stay:4') = $display_text))",
				"$fade_stay_time": 4
			},
			{
				"requires": "(not (($display_text - 'alpha_stay:5') = $display_text))",
				"$fade_stay_time": 5
			},
			{
				"requires": "(not (($display_text - 'alpha_stay:6') = $display_text))",
				"$fade_stay_time": 6
			},
			{
				"requires": "(not (($display_text - 'alpha_stay:7') = $display_text))",
				"$fade_stay_time": 7
			},
			{
				"requires": "(not (($display_text - 'alpha_stay:8') = $display_text))",
				"$fade_stay_time": 8
			},
			{
				"requires": "(not (($display_text - 'alpha_stay:9') = $display_text))",
				"$fade_stay_time": 9
			},
			{
				"requires": "(not (($display_text - 'alpha_stay:10') = $display_text))",
				"$fade_stay_time": 10
			},
			{
				"requires": "(not (($display_text - 'alpha_stay:11') = $display_text))",
				"$fade_stay_time": 11
			},
			{
				"requires": "(not (($display_text - 'alpha_stay:12') = $display_text))",
				"$fade_stay_time": 12
			},
			{
				"requires": "(not (($display_text - 'alpha_stay:13') = $display_text))",
				"$fade_stay_time": 13
			},
			{
				"requires": "(not (($display_text - 'alpha_stay:14') = $display_text))",
				"$fade_stay_time": 14
			},
			{
				"requires": "(not (($display_text - 'alpha_stay:15') = $display_text))",
				"$fade_stay_time": 15
			},
			{
				"requires": "(not (($display_text - 'alpha_stay:16') = $display_text))",
				"$fade_stay_time": 16
			},
			{
				"requires": "(not (($display_text - 'alpha_stay:17') = $display_text))",
				"$fade_stay_time": 17
			},
			{
				"requires": "(not (($display_text - 'alpha_stay:18') = $display_text))",
				"$fade_stay_time": 18
			},
			{
				"requires": "(not (($display_text - 'alpha_stay:19') = $display_text))",
				"$fade_stay_time": 19
			},
			{
				"requires": "(not (($display_text - 'alpha_stay:20') = $display_text))",
				"$fade_stay_time": 20
			},
			{
				"requires": "(not (($display_text - 'alpha_out:0') = $display_text))",
				"$fade_out_time": 0
			},
			{
				"requires": "(not (($display_text - 'alpha_out:1') = $display_text))",
				"$fade_out_time": 1
			},
			{
				"requires": "(not (($display_text - 'alpha_out:2') = $display_text))",
				"$fade_out_time": 2
			},
			{
				"requires": "(not (($display_text - 'alpha_out:3') = $display_text))",
				"$fade_out_time": 3
			},
			{
				"requires": "(not (($display_text - 'alpha_out:4') = $display_text))",
				"$fade_out_time": 4
			},
			{
				"requires": "(not (($display_text - 'alpha_out:5') = $display_text))",
				"$fade_out_time": 5
			},
			{
				"requires": "(not (($display_text - 'scale_in:0') = $display_text))",
				"$scale_in_time": 0
			},
			{
				"requires": "(not (($display_text - 'scale_in:1') = $display_text))",
				"$scale_in_time": 1
			},
			{
				"requires": "(not (($display_text - 'scale_in:2') = $display_text))",
				"$scale_in_time": 2
			},
			{
				"requires": "(not (($display_text - 'scale_in:3') = $display_text))",
				"$scale_in_time": 3
			},
			{
				"requires": "(not (($display_text - 'scale_in:4') = $display_text))",
				"$scale_in_time": 4
			},
			{
				"requires": "(not (($display_text - 'scale_in:5') = $display_text))",
				"$scale_in_time": 5
			},
			{
				"requires": "(not (($display_text - 'scale_stay:0') = $display_text))",
				"$scale_stay_time": 0
			},
			{
				"requires": "(not (($display_text - 'scale_stay:1') = $display_text))",
				"$scale_stay_time": 1
			},
			{
				"requires": "(not (($display_text - 'scale_stay:2') = $display_text))",
				"$scale_stay_time": 2
			},
			{
				"requires": "(not (($display_text - 'scale_stay:3') = $display_text))",
				"$scale_stay_time": 3
			},
			{
				"requires": "(not (($display_text - 'scale_stay:4') = $display_text))",
				"$scale_stay_time": 4
			},
			{
				"requires": "(not (($display_text - 'scale_stay:5') = $display_text))",
				"$scale_stay_time": 5
			},
			{
				"requires": "(not (($display_text - 'scale_stay:6') = $display_text))",
				"$scale_stay_time": 6
			},
			{
				"requires": "(not (($display_text - 'scale_stay:7') = $display_text))",
				"$scale_stay_time": 7
			},
			{
				"requires": "(not (($display_text - 'scale_stay:8') = $display_text))",
				"$scale_stay_time": 8
			},
			{
				"requires": "(not (($display_text - 'scale_stay:9') = $display_text))",
				"$scale_stay_time": 9
			},
			{
				"requires": "(not (($display_text - 'scale_stay:10') = $display_text))",
				"$scale_stay_time": 10
			},
			{
				"requires": "(not (($display_text - 'scale_stay:11') = $display_text))",
				"$scale_stay_time": 11
			},
			{
				"requires": "(not (($display_text - 'scale_stay:12') = $display_text))",
				"$scale_stay_time": 12
			},
			{
				"requires": "(not (($display_text - 'scale_stay:13') = $display_text))",
				"$scale_stay_time": 13
			},
			{
				"requires": "(not (($display_text - 'scale_stay:14') = $display_text))",
				"$scale_stay_time": 14
			},
			{
				"requires": "(not (($display_text - 'scale_stay:15') = $display_text))",
				"$scale_stay_time": 15
			},
			{
				"requires": "(not (($display_text - 'scale_stay:16') = $display_text))",
				"$scale_stay_time": 16
			},
			{
				"requires": "(not (($display_text - 'scale_stay:17') = $display_text))",
				"$scale_stay_time": 17
			},
			{
				"requires": "(not (($display_text - 'scale_stay:18') = $display_text))",
				"$scale_stay_time": 18
			},
			{
				"requires": "(not (($display_text - 'scale_stay:19') = $display_text))",
				"$scale_stay_time": 19
			},
			{
				"requires": "(not (($display_text - 'scale_stay:20') = $display_text))",
				"$scale_stay_time": 20
			},
			{
				"requires": "(not (($display_text - 'scale_out:0') = $display_text))",
				"$scale_out_time": 0
			},
			{
				"requires": "(not (($display_text - 'scale_out:1') = $display_text))",
				"$scale_out_time": 1
			},
			{
				"requires": "(not (($display_text - 'scale_out:2') = $display_text))",
				"$scale_out_time": 2
			},
			{
				"requires": "(not (($display_text - 'scale_out:3') = $display_text))",
				"$scale_out_time": 3
			},
			{
				"requires": "(not (($display_text - 'scale_out:4') = $display_text))",
				"$scale_out_time": 4
			},
			{
				"requires": "(not (($display_text - 'scale_out:5') = $display_text))",
				"$scale_out_time": 5
			},
			{
				"requires": "(not (($display_text - 'font:rune') = $display_text))",
				"$font": "rune"
			},
			{
				"requires": "(not (($display_text - 'font:unicode') = $display_text))",
				"$font": "unicode"
			},
			{
				"requires": "(not (($display_text - 'font:smooth') = $display_text))",
				"$font": "smooth"
			},
			{
				"requires": "(not (($display_text - 'font:MinecraftTen') = $display_text))",
				"$font": "MinecraftTen"
			},
			{
				"requires": "(not (($display_text - 'shadow:true') = $display_text))",
				"$show_shadow": true
			},
			{
				"requires": "(not (($display_text - 'scale') = $display_text))",
				"$animate_scale": true
			},
			{
				"requires": "(not (($display_text - 'size:2') = $display_text))",
				"$subject_size": [
					2,
					2
				]
			},
			{
				"requires": "(not (($display_text - 'size:4') = $display_text))",
				"$subject_size": [
					4,
					4
				]
			},
			{
				"requires": "(not (($display_text - 'size:8') = $display_text))",
				"$subject_size": [
					8,
					8
				]
			},
			{
				"requires": "(not (($display_text - 'size:16') = $display_text))",
				"$subject_size": [
					16,
					16
				]
			},
			{
				"requires": "(not (($display_text - 'size:32') = $display_text))",
				"$subject_size": [
					32,
					32
				]
			},
			{
				"requires": "(not (($display_text - 'size:64') = $display_text))",
				"$subject_size": [
					64,
					64
				]
			},
			{
				"requires": "(not (($display_text - 'size:128') = $display_text))",
				"$subject_size": [
					128,
					128
				]
			},
			{
				"requires": "(not (($display_text - 'size:256') = $display_text))",
				"$subject_size": [
					256,
					256
				]
			},
			{
				"requires": "(not (($display_text - 'size:384') = $display_text))",
				"$subject_size": [
					384,
					384
				]
			},
			{
				"requires": "(not (($display_text - 'size:512') = $display_text))",
				"$subject_size": [
					512,
					512
				]
			},
			{
				"requires": "(not (($display_text - 'size:1024') = $display_text))",
				"$subject_size": [
					1024,
					1024
				]
			},
			{
				"requires": "((not (($display_text - 'offset:1') = $display_text)) and $anchor = top_left)",
				"$subject_offset": [
					1,
					1
				]
			},
			{
				"requires": "((not (($display_text - 'offset:2') = $display_text)) and $anchor = top_left)",
				"$subject_offset": [
					2,
					2
				]
			},
			{
				"requires": "((not (($display_text - 'offset:3') = $display_text)) and $anchor = top_left)",
				"$subject_offset": [
					3,
					3
				]
			},
			{
				"requires": "((not (($display_text - 'offset:4') = $display_text)) and $anchor = top_left)",
				"$subject_offset": [
					4,
					4
				]
			},
			{
				"requires": "((not (($display_text - 'offset:5') = $display_text)) and $anchor = top_left)",
				"$subject_offset": [
					5,
					5
				]
			},
			{
				"requires": "((not (($display_text - 'offset:6') = $display_text)) and $anchor = top_left)",
				"$subject_offset": [
					6,
					6
				]
			},
			{
				"requires": "((not (($display_text - 'offset:7') = $display_text)) and $anchor = top_left)",
				"$subject_offset": [
					7,
					7
				]
			},
			{
				"requires": "((not (($display_text - 'offset:8') = $display_text)) and $anchor = top_left)",
				"$subject_offset": [
					8,
					8
				]
			},
			{
				"requires": "((not (($display_text - 'offset:9') = $display_text)) and $anchor = top_left)",
				"$subject_offset": [
					9,
					9
				]
			},
			{
				"requires": "((not (($display_text - 'offset:10') = $display_text)) and $anchor = top_left)",
				"$subject_offset": [
					10,
					10
				]
			},
			{
				"requires": "((not (($display_text - 'offset:1') = $display_text)) and $anchor = top_middle)",
				"$subject_offset": [
					0,
					1
				]
			},
			{
				"requires": "((not (($display_text - 'offset:2') = $display_text)) and $anchor = top_middle)",
				"$subject_offset": [
					0,
					2
				]
			},
			{
				"requires": "((not (($display_text - 'offset:3') = $display_text)) and $anchor = top_middle)",
				"$subject_offset": [
					0,
					3
				]
			},
			{
				"requires": "((not (($display_text - 'offset:4') = $display_text)) and $anchor = top_middle)",
				"$subject_offset": [
					0,
					4
				]
			},
			{
				"requires": "((not (($display_text - 'offset:5') = $display_text)) and $anchor = top_middle)",
				"$subject_offset": [
					0,
					5
				]
			},
			{
				"requires": "((not (($display_text - 'offset:6') = $display_text)) and $anchor = top_middle)",
				"$subject_offset": [
					0,
					6
				]
			},
			{
				"requires": "((not (($display_text - 'offset:7') = $display_text)) and $anchor = top_middle)",
				"$subject_offset": [
					0,
					7
				]
			},
			{
				"requires": "((not (($display_text - 'offset:8') = $display_text)) and $anchor = top_middle)",
				"$subject_offset": [
					0,
					8
				]
			},
			{
				"requires": "((not (($display_text - 'offset:9') = $display_text)) and $anchor = top_middle)",
				"$subject_offset": [
					0,
					9
				]
			},
			{
				"requires": "((not (($display_text - 'offset:10') = $display_text)) and $anchor = top_middle)",
				"$subject_offset": [
					0,
					10
				]
			},
			{
				"requires": "((not (($display_text - 'offset:1') = $display_text)) and $anchor = top_right)",
				"$subject_offset": [
					-1,
					1
				]
			},
			{
				"requires": "((not (($display_text - 'offset:2') = $display_text)) and $anchor = top_right)",
				"$subject_offset": [
					-2,
					2
				]
			},
			{
				"requires": "((not (($display_text - 'offset:3') = $display_text)) and $anchor = top_right)",
				"$subject_offset": [
					-3,
					3
				]
			},
			{
				"requires": "((not (($display_text - 'offset:4') = $display_text)) and $anchor = top_right)",
				"$subject_offset": [
					-4,
					4
				]
			},
			{
				"requires": "((not (($display_text - 'offset:5') = $display_text)) and $anchor = top_right)",
				"$subject_offset": [
					-5,
					5
				]
			},
			{
				"requires": "((not (($display_text - 'offset:6') = $display_text)) and $anchor = top_right)",
				"$subject_offset": [
					-6,
					6
				]
			},
			{
				"requires": "((not (($display_text - 'offset:7') = $display_text)) and $anchor = top_right)",
				"$subject_offset": [
					-7,
					7
				]
			},
			{
				"requires": "((not (($display_text - 'offset:8') = $display_text)) and $anchor = top_right)",
				"$subject_offset": [
					-8,
					8
				]
			},
			{
				"requires": "((not (($display_text - 'offset:9') = $display_text)) and $anchor = top_right)",
				"$subject_offset": [
					-9,
					9
				]
			},
			{
				"requires": "((not (($display_text - 'offset:10') = $display_text)) and $anchor = top_right)",
				"$subject_offset": [
					-10,
					10
				]
			},
			{
				"requires": "((not (($display_text - 'offset:1') = $display_text)) and $anchor = right_middle)",
				"$subject_offset": [
					-1,
					0
				]
			},
			{
				"requires": "((not (($display_text - 'offset:2') = $display_text)) and $anchor = right_middle)",
				"$subject_offset": [
					-2,
					0
				]
			},
			{
				"requires": "((not (($display_text - 'offset:3') = $display_text)) and $anchor = right_middle)",
				"$subject_offset": [
					-3,
					0
				]
			},
			{
				"requires": "((not (($display_text - 'offset:4') = $display_text)) and $anchor = right_middle)",
				"$subject_offset": [
					-4,
					0
				]
			},
			{
				"requires": "((not (($display_text - 'offset:5') = $display_text)) and $anchor = right_middle)",
				"$subject_offset": [
					-5,
					0
				]
			},
			{
				"requires": "((not (($display_text - 'offset:6') = $display_text)) and $anchor = right_middle)",
				"$subject_offset": [
					-6,
					0
				]
			},
			{
				"requires": "((not (($display_text - 'offset:7') = $display_text)) and $anchor = right_middle)",
				"$subject_offset": [
					-7,
					0
				]
			},
			{
				"requires": "((not (($display_text - 'offset:8') = $display_text)) and $anchor = right_middle)",
				"$subject_offset": [
					-8,
					0
				]
			},
			{
				"requires": "((not (($display_text - 'offset:9') = $display_text)) and $anchor = right_middle)",
				"$subject_offset": [
					-9,
					0
				]
			},
			{
				"requires": "((not (($display_text - 'offset:10') = $display_text)) and $anchor = right_middle)",
				"$subject_offset": [
					-10,
					0
				]
			},
			{
				"requires": "((not (($display_text - 'offset:1') = $display_text)) and $anchor = left_middle)",
				"$subject_offset": [
					1,
					0
				]
			},
			{
				"requires": "((not (($display_text - 'offset:2') = $display_text)) and $anchor = left_middle)",
				"$subject_offset": [
					2,
					0
				]
			},
			{
				"requires": "((not (($display_text - 'offset:3') = $display_text)) and $anchor = left_middle)",
				"$subject_offset": [
					3,
					0
				]
			},
			{
				"requires": "((not (($display_text - 'offset:4') = $display_text)) and $anchor = left_middle)",
				"$subject_offset": [
					4,
					0
				]
			},
			{
				"requires": "((not (($display_text - 'offset:5') = $display_text)) and $anchor = left_middle)",
				"$subject_offset": [
					5,
					0
				]
			},
			{
				"requires": "((not (($display_text - 'offset:6') = $display_text)) and $anchor = left_middle)",
				"$subject_offset": [
					6,
					0
				]
			},
			{
				"requires": "((not (($display_text - 'offset:7') = $display_text)) and $anchor = left_middle)",
				"$subject_offset": [
					7,
					0
				]
			},
			{
				"requires": "((not (($display_text - 'offset:8') = $display_text)) and $anchor = left_middle)",
				"$subject_offset": [
					8,
					0
				]
			},
			{
				"requires": "((not (($display_text - 'offset:9') = $display_text)) and $anchor = left_middle)",
				"$subject_offset": [
					9,
					0
				]
			},
			{
				"requires": "((not (($display_text - 'offset:10') = $display_text)) and $anchor = left_middle)",
				"$subject_offset": [
					10,
					0
				]
			},
			{
				"requires": "((not (($display_text - 'offset:1') = $display_text)) and $anchor = bottom_left)",
				"$subject_offset": [
					1,
					-1
				]
			},
			{
				"requires": "((not (($display_text - 'offset:2') = $display_text)) and $anchor = bottom_left)",
				"$subject_offset": [
					2,
					-2
				]
			},
			{
				"requires": "((not (($display_text - 'offset:3') = $display_text)) and $anchor = bottom_left)",
				"$subject_offset": [
					3,
					-3
				]
			},
			{
				"requires": "((not (($display_text - 'offset:4') = $display_text)) and $anchor = bottom_left)",
				"$subject_offset": [
					4,
					-4
				]
			},
			{
				"requires": "((not (($display_text - 'offset:5') = $display_text)) and $anchor = bottom_left)",
				"$subject_offset": [
					5,
					-5
				]
			},
			{
				"requires": "((not (($display_text - 'offset:6') = $display_text)) and $anchor = bottom_left)",
				"$subject_offset": [
					6,
					-6
				]
			},
			{
				"requires": "((not (($display_text - 'offset:7') = $display_text)) and $anchor = bottom_left)",
				"$subject_offset": [
					7,
					-7
				]
			},
			{
				"requires": "((not (($display_text - 'offset:8') = $display_text)) and $anchor = bottom_left)",
				"$subject_offset": [
					8,
					-8
				]
			},
			{
				"requires": "((not (($display_text - 'offset:9') = $display_text)) and $anchor = bottom_left)",
				"$subject_offset": [
					9,
					-9
				]
			},
			{
				"requires": "((not (($display_text - 'offset:10') = $display_text)) and $anchor = bottom_left)",
				"$subject_offset": [
					10,
					-10
				]
			},
			{
				"requires": "((not (($display_text - 'offset:1') = $display_text)) and $anchor = bottom_middle)",
				"$subject_offset": [
					0,
					-42
				]
			},
			{
				"requires": "((not (($display_text - 'offset:2') = $display_text)) and $anchor = bottom_middle)",
				"$subject_offset": [
					0,
					-43
				]
			},
			{
				"requires": "((not (($display_text - 'offset:3') = $display_text)) and $anchor = bottom_middle)",
				"$subject_offset": [
					0,
					-44
				]
			},
			{
				"requires": "((not (($display_text - 'offset:4') = $display_text)) and $anchor = bottom_middle)",
				"$subject_offset": [
					0,
					-45
				]
			},
			{
				"requires": "((not (($display_text - 'offset:5') = $display_text)) and $anchor = bottom_middle)",
				"$subject_offset": [
					0,
					-46
				]
			},
			{
				"requires": "((not (($display_text - 'offset:6') = $display_text)) and $anchor = bottom_middle)",
				"$subject_offset": [
					0,
					-47
				]
			},
			{
				"requires": "((not (($display_text - 'offset:7') = $display_text)) and $anchor = bottom_middle)",
				"$subject_offset": [
					0,
					-48
				]
			},
			{
				"requires": "((not (($display_text - 'offset:8') = $display_text)) and $anchor = bottom_middle)",
				"$subject_offset": [
					0,
					-49
				]
			},
			{
				"requires": "((not (($display_text - 'offset:9') = $display_text)) and $anchor = bottom_middle)",
				"$subject_offset": [
					0,
					-50
				]
			},
			{
				"requires": "((not (($display_text - 'offset:10') = $display_text)) and $anchor = bottom_middle)",
				"$subject_offset": [
					0,
					-51
				]
			},
			{
				"requires": "((not (($display_text - 'offset:1') = $display_text)) and $anchor = bottom_right)",
				"$subject_offset": [
					-1,
					-1
				]
			},
			{
				"requires": "((not (($display_text - 'offset:2') = $display_text)) and $anchor = bottom_right)",
				"$subject_offset": [
					-2,
					-2
				]
			},
			{
				"requires": "((not (($display_text - 'offset:3') = $display_text)) and $anchor = bottom_right)",
				"$subject_offset": [
					-3,
					-3
				]
			},
			{
				"requires": "((not (($display_text - 'offset:4') = $display_text)) and $anchor = bottom_right)",
				"$subject_offset": [
					-4,
					-4
				]
			},
			{
				"requires": "((not (($display_text - 'offset:5') = $display_text)) and $anchor = bottom_right)",
				"$subject_offset": [
					-5,
					-5
				]
			},
			{
				"requires": "((not (($display_text - 'offset:6') = $display_text)) and $anchor = bottom_right)",
				"$subject_offset": [
					-6,
					-6
				]
			},
			{
				"requires": "((not (($display_text - 'offset:7') = $display_text)) and $anchor = bottom_right)",
				"$subject_offset": [
					-7,
					-7
				]
			},
			{
				"requires": "((not (($display_text - 'offset:8') = $display_text)) and $anchor = bottom_right)",
				"$subject_offset": [
					-8,
					-8
				]
			},
			{
				"requires": "((not (($display_text - 'offset:9') = $display_text)) and $anchor = bottom_right)",
				"$subject_offset": [
					-9,
					-9
				]
			},
			{
				"requires": "((not (($display_text - 'offset:10') = $display_text)) and $anchor = bottom_right)",
				"$subject_offset": [
					-10,
					-10
				]
			},
			{
				"requires": "(not $is_vanilla)",
				"$custom_actionbar_keywords_text": "($display_text - '{' - '}' - 'img' - 'txt' - 'bg' - 'shadow' - 'hide' - ',' - 'size:1024' - 'size:512' - 'size:384' - 'size:256' - 'size:128' - 'size:64' - 'size:32' - 'size:16' - 'size:8' - 'size:4' - 'size:2' - 'alpha:0.0' - 'alpha:0.1' - 'alpha:0.2' - 'alpha:0.3' - 'alpha:0.4' - 'alpha:0.5' - 'alpha:0.6' - 'alpha:0.7' - 'alpha:0.8' - 'alpha:0.9' - 'alpha:1.0' - 'anchor:top_left' - 'anchor:top_middle' - 'anchor:top_right' - 'anchor:left_middle' - 'anchor:center' - 'anchor:right_middle' - 'anchor:bottom_left' - 'anchor:bottom_middle' - 'anchor:bottom_right' - 'alpha_out:5' - 'alpha_out:4' - 'alpha_out:3' - 'alpha_out:2' - 'alpha_out:1' - 'alpha_out:0' - 'alpha_stay:20' - 'alpha_stay:19' - 'alpha_stay:18' - 'alpha_stay:17' - 'alpha_stay:16' - 'alpha_stay:15' - 'alpha_stay:14' - 'alpha_stay:13' - 'alpha_stay:12' - 'alpha_stay:11' - 'alpha_stay:10' - 'alpha_stay:9' - 'alpha_stay:8' - 'alpha_stay:7' - 'alpha_stay:6' - 'alpha_stay:5' - 'alpha_stay:4' - 'alpha_stay:3' - 'alpha_stay:2' - 'alpha_stay:1' - 'alpha_stay:0' - 'alpha_in:5' - 'alpha_in:4' - 'alpha_in:3' - 'alpha_in:2' - 'alpha_in:1' - 'alpha_in:0' - 'scale_out:5' - 'scale_out:4' - 'scale_out:3' - 'scale_out:2' - 'scale_out:1' - 'scale_out:0' - 'scale_stay:20' - 'scale_stay:19' - 'scale_stay:18' - 'scale_stay:17' - 'scale_stay:16' - 'scale_stay:15' - 'scale_stay:14' - 'scale_stay:13' - 'scale_stay:12' - 'scale_stay:11' - 'scale_stay:10' - 'scale_stay:9' - 'scale_stay:8' - 'scale_stay:7' - 'scale_stay:6' - 'scale_stay:5' - 'scale_stay:4' - 'scale_stay:3' - 'scale_stay:2' - 'scale_stay:1' - 'scale_stay:0' - 'scale_in:5' - 'scale_in:4' - 'scale_in:3' - 'scale_in:2' - 'scale_in:1' - 'scale_in:0' - 'font:rune' - 'font:unicode' - 'font:smooth' - 'font:MinecraftTen' - 'offset:10' - 'offset:9' - 'offset:8' - 'offset:7' - 'offset:6' - 'offset:5' - 'offset:4' - 'offset:3' - 'offset:2' - 'offset:1' - ':true' - ':false' - ':')"
			}
		]
	},
	"image_actionbar": {
		"type": "image",
		"texture": "$texture_path",
		"$texture_path": "$custom_actionbar_keywords_text",
		"$display_size": "$subject_size",
		"size": "$display_size",
		"anchor_from": "$anchor",
		"anchor_to": "$anchor",
		"offset": "$subject_offset",
		"alpha": "@custom_actionbar.anim_custom_actionbar_subject_alpha_in",
		"variables": [
			{
				"requires": "$animate_scale",
				"$display_size": "@custom_actionbar.anim_custom_actionbar_subject_scale_in"
			}
		]
	},
	"label_actionbar": {
		"type": "image",
		"size": [
			"100%c + 12px",
			"100%c + 5px"
		],
		"offset": "$offset",
		"texture": "textures/ui/hud_tip_text_background",
		"anchor_from": "$anchor",
		"anchor_to": "$anchor",
		"alpha": "@custom_actionbar.anim_custom_actionbar_background_alpha_in",
		"$offset": [
			0,
			0
		],
		"$scale": 1,
		"controls": [
			{
				"actionbar_message": {
					"type": "label",
					"font_scale_factor": "$scale",
					"font_type": "$font",
					"anchor_from": "center",
					"anchor_to": "center",
					"color": "$tool_tip_text",
					"layer": 31,
					"text": "$custom_actionbar_keywords_text",
					"localize": true,
					"shadow": "$show_shadow",
					"text_alignment": "center",
					"alpha": "@custom_actionbar.anim_custom_actionbar_subject_alpha_in"
				}
			}
		],
		"variables": [
			{
				"requires": "$pin_to_actionbar",
				"$offset": [
					0,
					"50%-78px"
				]
			},
			{
				"requires": "(not $pin_to_actionbar)",
				"$offset": "$subject_offset"
			},
			{
				"requires": "(not (($display_text - 'size:2') = $display_text))",
				"$scale": 2
			},
			{
				"requires": "(not (($display_text - 'size:4') = $display_text))",
				"$scale": 4
			},
			{
				"requires": "(not (($display_text - 'size:8') = $display_text))",
				"$scale": 8
			},
			{
				"requires": "(not (($display_text - 'size:16') = $display_text))",
				"$scale": 16
			}
		]
	},
	"vanilla_actionbar": {
		"type": "image",
		"size": [
			"100%c + 12px",
			"100%c + 5px"
		],
		"offset": [
			0,
			"50%-78px"
		],
		"texture": "textures/ui/hud_tip_text_background",
		"$bg_alpha": 0,
		"$txt_alpha": 0,
		"alpha": "$bg_alpha",
		"controls": [
			{
				"actionbar_message": {
					"type": "label",
					"anchor_from": "center",
					"anchor_to": "center",
					"color": "$tool_tip_text",
					"layer": 31,
					"text": "$display_text",
					"localize": false,
					"alpha": "$txt_alpha"
				}
			}
		],
		"variables": [
			{
				"requires": "$is_vanilla",
				"$bg_alpha": "@hud.anim_actionbar_text_background_alpha_out",
				"$txt_alpha": "@hud.anim_actionbar_text_alpha_out"
			}
		]
	},
	// #region Animations
	// Alpha Animations
	"anim_custom_actionbar_subject_alpha_in": {
		"anim_type": "alpha",
		"easing": "linear",
		"duration": "$fade_in_time",
		"from": 0,
		"to": "$subject_alpha",
		"next": "@custom_actionbar.anim_custom_actionbar_subject_alpha_stay"
	},
	"anim_custom_actionbar_subject_alpha_stay": {
		"anim_type": "wait",
		"duration": "$fade_stay_time",
		"next": "@custom_actionbar.anim_custom_actionbar_subject_alpha_out"
	},
	"anim_custom_actionbar_subject_alpha_out": {
		"anim_type": "alpha",
		"easing": "linear",
		"duration": "$fade_out_time",
		"from": "$subject_alpha",
		"to": 0
	},
	"anim_custom_actionbar_background_alpha_in": {
		"anim_type": "alpha",
		"easing": "linear",
		"duration": "$fade_in_time",
		"from": 0,
		"to": "$background_alpha",
		"next": "@custom_actionbar.anim_custom_actionbar_background_alpha_stay"
	},
	"anim_custom_actionbar_background_alpha_stay": {
		"anim_type": "wait",
		"duration": "$fade_stay_time",
		"next": "@custom_actionbar.anim_custom_actionbar_background_alpha_out"
	},
	"anim_custom_actionbar_background_alpha_out": {
		"anim_type": "alpha",
		"easing": "linear",
		"duration": "$fade_out_time",
		"from": "$background_alpha",
		"to": 0
	},
	// Scale Animations
	"anim_custom_actionbar_subject_scale_in": {
		"anim_type": "size",
		"easing": "linear",
		"duration": "$scale_in_time",
		"from": [
			0,
			0
		],
		"to": "$subject_size",
		"next": "@custom_actionbar.anim_custom_actionbar_subject_scale_stay"
	},
	"anim_custom_actionbar_subject_scale_stay": {
		"anim_type": "wait",
		"duration": "$scale_stay_time",
		"next": "@custom_actionbar.anim_custom_actionbar_subject_scale_out"
	},
	"anim_custom_actionbar_subject_scale_out": {
		"anim_type": "size",
		"easing": "linear",
		"duration": "$scale_out_time",
		"from": "$subject_size",
		"to": [
			0,
			0
		]
	}
	// #endregion
}